<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <meta http-equiv="X-UA-Compatible" content="IE=edge" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Document</title>
  </head>
  <body>
    <script>
      /*  
       1. Сделайте класс User, в котором будут следующие свойства - name (имя), age (возраст).	
       2. Сделайте метод setAge, который параметром будет принимать новый возраст пользователя.
       3. Сделайте класс Employee, который будет наследовать от класса User и 
       расширьте его 1 новым свойством и 1 новым методом
       4.Сделайте класс Programmer, который будет наследовать от класса Employee. 
       Пусть новый класс имеет свойство langs, в котором будет хранится массив языков, 
       которыми владеет программист. Сделайте также геттер и сеттер для этого свойства. 	
      5. Сделайте класс Driver (водитель), который будет наследовать от класса Employee. 
      Пусть новый класс добавляет следующие свойства: водительский стаж, категория вождения 
      (A, B, C, D), а также геттеры и сеттеры к ним.
     */

    class User {
      constructor (name, age) {
        this.name = name;
        this.age = age;
      }
      getAge () {
        return this.name = name;
      }
      setAge () {
        this.age = newAge;
      }
    }
    
    class Employee extends User {
      constructor (name, age, salary) {
        super(name, age);
        this.salary = salary;
      }
      getSalary () {
        return this.salary;
      }
    }

    class Programmer extends Employee {
      constructor(name, age, salary, langs) {
        super(name, age, salary)
        this._langs = langs;
      }
      get langs () {
        return this._langs;
      }
      set lang () {
        this.langs = newLangs;
      }
    }

    class Driver extends Employee {
      constructor(name, age, salary, exp, category) {
        super (name, age, salary);
        this._exp = exp;
        this._category = category;
      }
      get exp () {
        return this._exp;
      }
      set category (newCategory) {
        const validCategory = ['A', 'B', 'C', 'D']
        if(validCategory.includes(newCategory)){
          this._category = newCategory;
        }
      }
    }


    
      // class User {
      //   constructor(name, age) {
      //     this.name = name;
      //     this.age = age;
      //   }
      //   setAge(newAge) {
      //     this.age = newAge;
      //   }
      // }
      // class Employee extends User {
      //   constructor(name, age, salary) {
      //     super(name, age);
      //     this.salary = salary;
      //   }
      //   getSalary() {
      //     return this.salary;
      //   }
      //   get salary() {
      //     return this.salary;
      //   }
      // }

      // const newEmployee = new Employee("vlada", 18, 2000);
      // newEmployee.getSalary();
      // newEmployee.salary;

      // class Programmer extends Employee {
      //   constructor(name, age, salary, langs) {
      //     super(name, age, salary);
      //     this._langs = langs;
      //   }
      //   get langs() {
      //     return this._langs;
      //   }
      //   set langs(newLangs) {
      //     this._langs = newLangs;
      //   }
      // }

      // class Driver extends Employee {
      //   constructor(name, age, salary, exp, category) {
      //     super(name, age, salary);
      //     this._exp = exp;
      //     this._category = category;
      //   }
      //   get exp() {
      //     return this._exp;
      //   }
      //   set category(newCategory) {
      //     const validCategory = ["A", "B", "C", "D"];
      //     if (validCategory.includes(newCategory)) {
      //       this._category = newCategory;
      //     }
      //   }
      // }
    </script>
  </body>
</html>
